extern int port,baudrate;
extern BOOL done;
extern HANDLE hCom;
extern CWinThread* pMyThread;
extern CString callsign,ssid,tnc,digicallsign,digissid;
extern BOOL tags;
extern CString texts;
extern BOOL qrz;
extern int servicenum;
extern CString startstr;
extern CString stopstr;

class SimpleHTTPClientSocket : public CAsyncSocket
{
private:

	CString m_Request;

	BYTE m_DataBuf[65536];
	BYTE m_OutBuf[65536];
	HANDLE hSource;
	DWORD dwW;
	BOOL fSuccess, DSpace;
	int i,j,count;
	CString od;


public:



	SimpleHTTPClientSocket ( CString request) {  
		m_Request = "GET " + request + " HTTP/1.0\r\n\r\n";
		
	}

	virtual void OnConnect (int nErrorCode) {
		if (nErrorCode == 0) {
			int len = m_Request.GetLength();
			Send(m_Request.GetBuffer(len), len);
			j = 0;
		}
		else {
//			AfxMessageBox("Unable to connect");
		}
	}
//----------What to do When Data is received .. Add it to Buffer m_DataBuf ---------
	virtual void OnReceive (int nErrorCode) {
		int NumBytes = Receive(&m_DataBuf, sizeof(m_DataBuf));
	
		
		for (i = 0;i < NumBytes;i++){
			m_OutBuf[j] = m_DataBuf[i];
			j++;
		}


	}
//-----------What to do after all the Data is received ... Process and Transmit---------
	virtual void OnClose (int nErrorCode) {

		char cr = 0x0d;
		unsigned char FEND[]={192};
		unsigned char DATA[]={0};
		unsigned char myhead1[]= {144,168,168,160,64,64,96,64,64,64,64,64,64,96};  //packet header
		unsigned char digi[] = {32,32,32,32,32,32,61};
		unsigned char myhead2[] = {3,240};


//		unsigned char myhead[]= {144,168,168,160,64,64,96,64,64,64,64,64,64,97,3,240};  //packet header
		int Numin,NumBytes,offset;
		Numin = j;
		count =0;
		DSpace = FALSE;
		i = j = 0;

		
		if (tags == FALSE){
			if (Numin > 3){      //Look for the beginning of HTTP data
				while (((m_OutBuf[i] != '<') | (toupper(m_OutBuf[i+1]) != 'H') |(toupper(m_OutBuf[i+2]) != 'T') | (toupper(m_OutBuf[i+3]) != 'M') |(toupper(m_OutBuf[i+4]) != 'L') | (m_OutBuf[i+5] != '>')) & (i < Numin)){
					(i++);
				}
							
			}
//---------Process the Data for Transmission into m_DataBuf------------
			if (i == Numin) (i=0);
			while (i< Numin){    
				if (m_OutBuf[i] == '<'){   //Get rid of all HTML Tags
					while ((m_OutBuf[i] != '>') & (i < Numin)){
						i++;
					}
				}
				else if ((m_OutBuf[i] == '&') & (m_OutBuf[i+1] == 'n') & (m_OutBuf[i+2] == 'b') & (m_OutBuf[i+3] == 's') & (m_OutBuf[i+4] == 'p') & (m_OutBuf[i+5] == ';')){//get rid of &nbsp;
					i = i+5;
				}
				else{
					if ((m_OutBuf[i] != 0x09) & (i<Numin)){ //get rid of the 0x09 (TAB)  character
						if ((m_OutBuf[i] == 0x0A)| (m_OutBuf[i] == 0x0D)) {
							if (DSpace == FALSE){
								m_DataBuf[j] = 0x0D;
								j++;
							}
						  DSpace = TRUE;
						}
						else{
							DSpace = FALSE;
							m_DataBuf[j] = m_OutBuf[i];
							j++;
						}
					}
				}
				i++;
			}
			NumBytes = j;
		}
		if (j==0) (NumBytes = Numin);
		
	if (servicenum >-1){   //clip webpage and process service request
			od = m_DataBuf;
			od = od.Left(NumBytes);
			if (startstr.GetLength() != 0){		//cut off all before startstr
				i = od.Find(startstr);
				od = od.Mid(i+startstr.GetLength());
			}
			if (stopstr.GetLength() != 0){
				j = od.Find(stopstr);
				od = od.Left(j);				//cut off all after stopstr
			}
			for (i=0;i<od.GetLength();i++) (m_DataBuf[i]= od.GetAt(i));
			NumBytes = od.GetLength();
		}



		// Following for testing purposes only
//		hSource = CreateFile("OUTPUT.TXT",GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,0);
//		fSuccess = WriteFile(hSource,&m_DataBuf,sizeof(m_DataBuf),&dwW,NULL);
//		CloseHandle(hSource);

//--------Process the Data for KISS packets------------------	
		for (i=0;i<NumBytes;i++){
			switch (m_DataBuf[i]){
			case 0xC0:
				for (j=NumBytes;j>i;j--) (m_DataBuf[j+1] = m_DataBuf[j]);  //stuff extra byte
				m_DataBuf[i] = 219;
				m_DataBuf[i+1] = 220;
				NumBytes++;
				break;
			case 0xDB:
				for (j=NumBytes;j>i;j--) (m_DataBuf[j+1] = m_DataBuf[j]);
				m_DataBuf[i] = 219;
				m_DataBuf[i+1] = 221;
				NumBytes++;
				break;
			}//end of case
		} //end of for

//-------Get the AX.25 Header----------	
		while (callsign.GetLength() <6) (callsign+= " ");//pad with spaces
	    for (i=7;i<13;i++) (myhead1[i] = (callsign.GetAt(i-7))<<1);// put callsign in myhead
		while (digicallsign.GetLength() <6) (digicallsign+= " ");//pad with spaces
		for (i=0;i<6;i++){
			(digi[i] = (digicallsign.GetAt(i))<<1);// put callsign in myhead
		}
		digi[6] = (digissid.GetAt(0)<<1) +1;
		if (digi[0] == ' ') (myhead1[13]=(ssid.GetAt(0)<<1) + 1);  //Add the SSID to the callsign
			else myhead1[13]=(ssid.GetAt(0)<<1);
//-------Transmit the Data--------------
		
		
		
		
		offset = 0;
		while (offset < NumBytes) {
			fSuccess = WriteFile(hCom,&FEND,1,&dwW,NULL);
			WriteFile(hCom,&DATA,1,&dwW,NULL);
//	  		WriteFile(hCom,&myhead,16,&dwW,NULL);
			WriteFile(hCom,&myhead1,14,&dwW,NULL);
			if (digi[0] !=' '){
			 (WriteFile(hCom,&digi,7,&dwW,NULL));
			}//transmit the path if it isn't 0's
			
			WriteFile(hCom,&myhead2,2,&dwW,NULL);
			for (i = 0;i < 256;i++){
				if ((i+offset) < NumBytes) (WriteFile(hCom,&m_DataBuf[i+offset],1,&dwW,NULL));
			}
			offset = offset+i-1;
			fSuccess= WriteFile(hCom,&FEND,1,&dwW,NULL);
			Sleep(2000);
		}
		pMyThread->PostThreadMessage(WM_QUIT,NULL,NULL);
		done = TRUE;
		delete this;
	}
};
